#include<iostream>
using namespace std;

class RecyclingVector
{
private:
	int n;
	int* m;
public:
	RecyclingVector();
	RecyclingVector(int a, int b[]);			//New
	void operator=(const RecyclingVector& v);	//Assignment
	const RecyclingVector operator+(const RecyclingVector& v);
	const RecyclingVector operator+(int i);		//Sum
	const RecyclingVector operator-(const RecyclingVector& v);
	const RecyclingVector operator-(int i);		//Minus
	int operator[](int i) const;
	int& operator[](int i); 					//Indexing
	bool operator<(const RecyclingVector& v);
	bool operator>(const RecyclingVector& v);
	bool operator==(const RecyclingVector& v);	//Comparison
};

int main(){
	RecyclingVector* vec[26] = {NULL};	//a pointer array of RecyclingVector
	char event, c1, c2, cmp;
	int num, num2;
	while(cin>>event){
		if(event=='N' || event=='A'){	//if N or A
			cin >> c1 >> num;
			int* arr = new int[num];
			for(int i=0; i<num; i++){
				cin >> arr[i];
			}
			int vecIndex = c1 - 'a';	//index of the vector(0~25)
			
			if(event=='N'){
				vec[vecIndex] = new RecyclingVector(num,arr);	//create a vector and initialize with n and array
			}
			if(event=='A'){
				RecyclingVector aVec(num,arr);	//creater a new vector
				*vec[vecIndex] = aVec;			//use the overloaded operator = to do the assignment
			}
		}
		else if(event=='S' || event=='M'){		//if S or M
			cin >> num >> c1 ;
			int vecIndex = c1 - 'a';
			RecyclingVector result;
			for(int i=0; i<num-1; i++){			//c2 to cm
				cin>> c2;
				int vecIndex2 = c2 - 'a';
				if(i==0){
					result = *vec[vecIndex2];	//first vector
				}
				else{
					if(event=='S')
						result = result + *vec[vecIndex2];	//use the overloaded operator +
					if(event=='M')
						result = result - *vec[vecIndex2];	//use the overloaded operator -
				}
			}
			if(vec[vecIndex] == NULL)
				vec[vecIndex] = new RecyclingVector;
			*vec[vecIndex] = result;
		}
		else if(event=='I'){				//if I
			cin >> c1 >> num >> num2;
			int vecIndex = c1 - 'a';
			(*vec[vecIndex])[num] = num2;	//assign new number to vec[vecIndex] with the overloaded []
		}
		else if(event=='C'){				//if C
			cin >> cmp >> c1 >> c2;
			int i1 = c1-'a';
			int i2 = c2-'a';
			if(cmp=='L'){					//output the result
				cout <<  (*vec[i1] < *vec[i2]) << endl;		//use the overloaded <
			}else if(cmp=='G'){
				cout <<  (*vec[i1] > *vec[i2]) << endl;		//use the overloaded >
			}else if(cmp=='E'){
				cout <<  (*vec[i1] == *vec[i2]) << endl;	//use the overloaded ==
			}
		}
	}
	return 0;
}

//default constructor
RecyclingVector::RecyclingVector()
{
	this->n = 0;
	this->m = NULL;
}
//constructor with arguments
RecyclingVector::RecyclingVector(int num, int arr[])
{
	this->n = num;
	this->m = new int[num];
	for(int i=0; i<num; i++)
		m[i] = arr[i];
}
//overloading assignment =
void RecyclingVector::operator=(const RecyclingVector& v)
{
	if(this->n != v.n){		//if two vectors have different length
		delete [] this->m;	//delete the old array and create a new one
		this->n = v.n;
		this->m = new int[this->n];
	}
	for(int i = 0; i < n; i++)
		this->m[i] = v.m[i];
}

//overloading addition operator + 
const RecyclingVector RecyclingVector::operator+(const RecyclingVector& v)
{
	RecyclingVector sum;	//creating a local variable
	if(this->n == v.n){
		sum = *this;
		for(int i = 0; i < n; i++)
			sum.m[i] = this->m[i] + v.m[i];
	}
	else{
		int max;
		if(this->n > v.n){	//find the longer vector and max length
			max = this->n;
			sum = *this;
		}else{
			max = v.n;
			sum = v;
		}
		for(int i = 1; i <= max; i++)
			sum[i] = (*this)[i] + v[i];	//use the overloaded [] to recycle the short vector
	}
	return sum;
}
//overloading subtraction operator -
const RecyclingVector RecyclingVector::operator-(const RecyclingVector& v)
{
	RecyclingVector dif;
	if(this->n == v.n){
		dif = *this;	//creating a local variable
		for(int i = 0; i < n; i++)
			dif.m[i] = this->m[i] - v.m[i];
	}
	else{
		int max;
		if(this->n > v.n){	//find the longer vector and max length
			max = this->n;
			dif = *this;
		}else{
			max = v.n;
			dif = v;
		}
		for(int i = 1; i <= max; i++)
			dif[i] = (*this)[i] - v[i];	//use the overloaded [] to recycle the short vector
	}
	return dif;
}

//overloading indexing operator [] which returns a integer
int RecyclingVector::operator[](int i) const 
{
	int index = (i-1)%(this->n);
	return m[index]; 
}
//overloading indexing operator [] which returns a reference
//Modifying that reference modifies the variable
int& RecyclingVector::operator[](int i) 
{ 
	int index = (i-1)%(this->n);
	return m[index]; 
} 

//overloading comparison operator <
bool RecyclingVector::operator<(const RecyclingVector& v)
{
	int max = this->n;
	if(v.n > max) 	//find the max length
		max = v.n;
	for(int i = 1; i <= max; i++){
		if((*this)[i] >= v[i])	//use the overloaded [] to recycle the short vector
			return false;		//if any violation occurs, return false
	}
	return true;
}
//overloading comparison operator >
bool RecyclingVector::operator>(const RecyclingVector& v)
{
	int max = this->n;
	if(v.n > max)
		max = v.n;
	for(int i = 1; i <= max; i++){
		if((*this)[i] <= v[i])
			return false;
	}
	return true;
}
//overloading comparison operator ==
bool RecyclingVector::operator==(const RecyclingVector& v) 
{
	int max = this->n;
	if(v.n > max)
		max = v.n;
	for(int i = 1; i <= max; i++){
		if((*this)[i] != v[i])
			return false;
	}
	return true;
}
